function [Psi,Phih]=Psiwt(Phi,p,m,h)
% Given m-VAR(p) coefficients Phi_1,...,Phi_p in Phi and lead time h
% returns impulse response coefficients I,Psi_1,...,Psi_{h-1} in Psi 
% and coefficients Phih_1,...,Phih_p of multistep predictor in Phih.
%
% disp('Release version of Psiwt')
%
Psi=zeros(m,m,h);
Psi(:,:,1)=eye(m);
Phih=zeros(m,m,p);
for k=1:h
    A=Psi(:,:,k);
    for j=1:p-1
        Phih(:,:,j)=Phih(:,:,j+1)+A*Phi(:,:,j);
    end
    Phih(:,:,p)=A*Phi(:,:,p);
    if k<h
        Psi(:,:,k+1)=Phih(:,:,1);
    end
end