function a=VARdet(phi,m,p)
% forms coefficients in a of the determinant of a canonical mxm VAR operator Phi(z)
% given matrix coefficients Phi_1 ... Phi_p in phi. Note sign convention requires negation of these in the code.
% The (P+1) length vector a holds scalar coefficients of det(Phi(z))=a_0 + a_1 z + ... + a_P z^P , P=m*p
%  with initial term monic a_0=1
% The method is to evaluate Phi(z) at points on the unit circle using the FFT,
% to evaluate the determinants of Phi(z) at these points,
% then to transform back to the coefficients of det(Phi(z)) using the inverse FFT
% disp('Release version of VARdet')
p1=p+1;
phix=zeros(m,m,p1);
phix(:,:,1)=eye(m);
for k=1:p
    phix(:,:,k+1)=-squeeze(phi(:,:,k));
end
phix;
P=m*p;
P1=P+1;
N=P1;
dTphix=zeros(1,N);
Tphix=fft(phix,P1,3);
for k=1:P1
    dTphix(k)=det(squeeze(Tphix(:,:,k)));
end
idTphix=real(ifft(dTphix));
a=idTphix(1:P1);
return
